=== debian/changelog ===
ros-lunar-libg2o (2017.4.2-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 02 Apr 2017 13:21:02 -0000
